#ifndef ARMAGENT_H_INCLUDED
#define ARM_AGENTH_INCLUDED

/****************************************************************************/
/* armagent.h - ARM Agent Specific API Definitions                          */
/****************************************************************************/

#include "arm.h"		/*  ARM API definitions  */

/*  ARM Agent data structures  */


/***    Symbol definitions    ***/

enum arm_corr_addr_e { ARM_Addr_IPv4 = 1, ARM_Addr_IPv4p, ARM_Addr_IPv6,
		       ARM_Addr_IPv6p, ARM_Addr_SNA
		     };

/***	Data definitions    ***/


/*  Correlator structure definition */

typedef struct arm_correlator_t {
    unsigned16 length;		/*  Length of correlator  */
    unsigned8  format;		/*  Format of the correlator  */
    bit8       flags;		/*  Flags  */
    unsigned16 addr_format;	/*  Format of the address  */
    unsigned16 vendor_id;       /*  IANA Vendor id */
    unsigned16 agent_version;   /*  Agent version number */
    unsigned16 agent_instance;  /*  Agent instance number */
    int32      start_handle;	/*  Transaction start handle  */
    int32      tran_id;		/*  Transaction id  */
    unsigned16 addr_length;     /*  Length of the address  */
    char       address[146];    /*  Agent contact info  */
} arm_correlator_t;


/***	Flag bit definitions    ****/

/*  flags in correlator */

#define ARM_AgentTrace_f 0x80	/*  Agent transaction trace requested  */
#define ARM_UserTrace_f  0x40	/*  User transaction trace requested  */


#endif /* ARMAGENT_H_INCLUDED */

