/****************************************************************************/
/* libarm.c - ARM 2.0 API Null Library                                      */
/****************************************************************************/

#include <sys/types.h>                 /* C types  definitions          */

#include "arm.h"

extern int32 ARM_API arm_init(
           char     *appname,          /* application name              */
           char     *appl_user_id,     /* Name of the application user  */
           int32     flags,            /* Reserved = 0                  */
           char     *data,             /* Reserved = NULL               */
           int32     data_size)        /* Reserved = 0                  */
{
  return 0;
}

extern int32 ARM_API arm_getid(
           int32     appl_id,          /* application id                */
           char     *tran_name,        /* transaction name              */
           char     *tran_detail,      /* transaction additional info   */
           int32     flags,            /* Reserved = 0                  */
           char     *data,             /* meta data definitions         */
           int32     data_size)        /* meta data size                */
{
  return 0;
}

extern int32 ARM_API arm_start(
           int32     tran_id,          /* transaction id                */
           int32     flags,            /* Reserved = 0                  */
           char     *data,             /* meta data and correlator      */
           int32     data_size)        /* meta data/correlator size     */
{
  return 0;
}

extern int32 ARM_API arm_update(
           int32     start_handle,     /* transaction instance handle   */
           int32     flags,            /* Reserved = 0                  */
           char     *data,             /* meta data and correlator      */
           int32     data_size)        /* meta data/correlator size     */
{
  return 0;
}

extern int32 ARM_API arm_stop(
           int32       start_handle,   /* unique transaction handle     */
           const int32 tran_status,    /* Good=0, Abort=1, Failed=2     */
           int32       flags,          /* Reserved = 0                  */
           char       *data,           /* meta data and correlator      */
           int32       data_size)      /* meta data/correlator size     */
{
  return 0;
}

extern int32 ARM_API arm_end( 
	   int32     appl_id,          /* application id                */
           int32     flags,            /* Reserved = 0                  */
           char     *data,             /* Reserved = NULL               */
           int32     data_size)        /* Reserved = 0                  */
{
  return 0;
}

static char *arm_version="@(#)libarm  (NOP)    A.02.00    10/22/97";

/*  This routine is not called, but is there so the what string will    */
/*  appear on all of the unix platforms.  There was some trouble in     */
/*  IBM AIX version 3.2.4 to get the version string to print and the    */
/*  combination of a static variable and having it referenced in the    */
/*  function below was the solution that worked for all platforms.      */
char *
arm_get_version()
{
  return(arm_version);
}
#if defined _WIN32 || _WIN16 || _WINDOWS
BOOL WINAPI DllMain(HINSTANCE hinstDll,
                    DWORD     fdwReason,
					LPVOID lpvReserved)
{
  return(TRUE);
}

#endif
