unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Simple_Transaction: TButton;
    Long_Transaction_Using_Update: TButton;
    Long_Transaction_Using_Sub_Transaction: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Simple_TransactionClick(Sender: TObject);
    procedure Long_Transaction_Using_UpdateClick(Sender: TObject);
    procedure Long_Transaction_Using_Sub_TransactionClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  appname:      AnsiString;
  appl_user_id: AnsiString;
  arm_user_id:  AnsiString;
  tran_name:    AnsiString;
  tran_detail:  AnsiString;
  data:         AnsiString;
  arm_handle:   Longint;
  appl_id:      Longint;
  tran_id:      Longint;
  flags:        Longint;
  data_size:    Longint;

  RetVal:         Longint;
  simple_tran_id: Longint;
  long_tran_id_1: Longint;
  long_tran_id_2: Longint;
  sub_tran_id_1:  Longint;
  sub_tran_id_2:  Longint;

const
  ARM_GOOD = 0;
  ARM_ABORT = 1;
  ARM_FAILED = 2;

implementation

function arm_init(appname: PChar; appl_user_id: PChar; flags: Longint;
                   data: PChar; data_size: Longint): Longint;
                   stdcall; external 'LIBARM32.DLL';
function arm_getid(appl_id: Longint; tran_name: PChar; tran_detal: PChar;
                   flags: Longint; data: PChar; data_size: Longint): Longint;
                   stdcall; external 'LIBARM32.DLL';
function arm_start(tran_id: Longint; flags: Longint; data: PChar;
                   data_size: Longint): Longint;
                   stdcall; external 'LIBARM32.DLL';
function arm_update(arm_handle: Longint; flags: Longint;
                    data: PChar; data_size: Longint): Longint;
                    stdcall; external 'LIBARM32.DLL';
function arm_stop(arm_handle: Longint; arm_status: Integer;
                  flags: Longint; data: PChar; data_size: Longint): Longint;
                  stdcall; external 'LIBARM32.DLL';
function arm_end(appl_id: Longint; flags: Longint;
                 data: PChar; data_size: Longint): Longint;
                 stdcall; external 'LIBARM32.DLL';

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  tran_name:    AnsiString;
  tran_detail:  AnsiString;

begin

//ARM Sample program - Application name
//*                  - Use default user
//0, 0, 0            - Reserved for future use

appname := 'ARM Sample Program';
appl_user_id := '*';
data := '0';
appl_id := arm_init(PChar(appname), PChar(appl_user_id), 0, PChar(data), 0);
if (appl_id <= -1) then
  MessageDlg('Application transaction monitoring init failed', mtError, [mbOK], 0)
else
  begin
    //appl_id        - Application Id returned form arm_init
    //Simple_tran_1  - Transaction name
    //First tran in sample program - Transaction description
    //0, 0, 0        - Reserved for future use.
    tran_name := 'Simple_tran_1';
    tran_detail := 'First tran in sample program';
    simple_tran_id := arm_getid(appl_id, PChar(tran_name), PChar(tran_detail),
                               0, PChar(data), 0);

    if (simple_tran_id <= -1) then
       MessageDlg('Simple Transaction_1 is not registered', mtError, [mbOK], 0);

    tran_name := 'Long_tran_1';
    tran_detail := 'First Long tran in sample program';
    long_tran_id_1 := arm_getid(appl_id, PChar(tran_name),
                    PChar(tran_detail), 0, PChar(data), 0);
    if (long_tran_id_1 <= -1) then
       MessageDlg('Long Transaction_1 is not registered', mtError, [mbOK], 0);

    tran_name := 'Long_tran_2';
    tran_detail := 'Second Long tran in sample program';
    long_tran_id_2 := arm_getid(appl_id, PChar(tran_name),
                    PChar(tran_detail), 0, PChar(data), 0);
    if (long_tran_id_2 <= -1) then
       MessageDlg('Long Transaction_2 is not registered', mtError, [mbOK], 0);

    tran_name := 'Sub_tran1_of_long_tran_2';
    tran_detail := 'Subtransation 1 of Long_transaction_2';
    sub_tran_id_1 := arm_getid(appl_id, PChar(tran_name),
                    PChar(tran_detail), 0, PChar(data), 0);
    if (sub_tran_id_1 <= -1) then
       MessageDlg('Sub_Transaction_1 is not registered', mtError, [mbOK], 0);

    tran_name := 'Sub_tran2_of_long_tran_2';
    tran_detail := 'Subtransation 2 of Long_transaction_2';
    sub_tran_id_2 := arm_getid(appl_id, PChar(tran_name),
                    PChar(tran_detail), 0, PChar(data), 0);
    if (sub_tran_id_2 <= -1) then
       MessageDlg('Sub_Transaction_2 is not registered', mtError, [mbOK], 0);

  end;  //End of else

 end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);

begin

  data := '0';
  //appl_id - Application Id returned form arm_init
  //0, 0, 0 - Reserved for future use
  RetVal := arm_end(appl_id, 0, PChar(data), 0);

end;

procedure TForm1.Simple_TransactionClick(Sender: TObject);
var
  tran_handle:    Longint;
begin

  data := '0';
  //simple_tran_id is the transation id from arm_getid and the
  //remaining three fields are reserved for future use.
  tran_handle := arm_start(simple_tran_id, 0, PChar(data), 0);

  //Perform actual transaction processing here
  sleep(10);

  //tran_handle - Transaction handle from arm_start
  //ARM_GOOD     - Succeful completion
  //0, 0, 0      - Three parameters reserved for future use
  RetVal := arm_stop(tran_handle, ARM_GOOD, 0, PChar(data), 0);

end;

procedure TForm1.Long_Transaction_Using_UpdateClick(Sender: TObject);
var
  tran_handle:    Longint;
  i:              Integer;
const
  MAX_COUNT = 1000;
  UPDATE_COUNT = 100;

begin
   data := '0';
   //tran_handle is the transaction handle from arm_start and the
   //remaining three fields are reserved for future use.
   tran_handle := arm_start(long_tran_id_1, 0, PChar(data), 0);

   //Perform actual transaction processing here
   for i := 1 to MAX_COUNT do
      if (i mod UPDATE_COUNT) = 0 then
         RetVal := arm_update(tran_handle, 0, PChar(data), 0);

   //tran_handle - Transaction handle from arm_start
   //ARM_GOOD    - Succeful completion
   //0, 0, 0     - Three parameters reserved for future use
   RetVal := arm_stop(tran_handle, ARM_GOOD, 0, PChar(data), 0);

end;

procedure TForm1.Long_Transaction_Using_Sub_TransactionClick(Sender: TObject);
var
  tran_handle:       Longint;
  sub_tran_handle_1: Longint;
  sub_tran_handle_2: Longint;
  i:                 Integer;

begin
   data := '0';
   //tran_handle is the transaction handle from arm_start and the
   //remaining three fields are reserved for future use.
   tran_handle := arm_start(long_tran_id_2, 0, PChar(data), 0);

   //start recording the first step of the long transation
   sub_tran_handle_1 := arm_start(sub_tran_id_1, 0, PChar(data), 0);

   //Process step 1 for this transation
   sleep(10);

   //Record the completion of the first step
   RetVal := arm_stop(sub_tran_handle_1, ARM_GOOD, 0, PChar(data), 0);

   //start recording the second step of the long transation
   sub_tran_handle_2 := arm_start(sub_tran_id_2, 0, PChar(data), 0);

   //Process step 1 for this transation
   sleep(10);

   //Record the completion of the first step
   RetVal := arm_stop(sub_tran_handle_2, ARM_GOOD, 0, PChar(data), 0);

   //Record the completion of the overall transaction
   //tran_handle - Transaction handle from arm_start
   //ARM_GOOD     - Succeful completion
   //0, 0, 0      - Three parameters reserved for future use
   RetVal := arm_stop(tran_handle, ARM_GOOD, 0, PChar(data), 0);

end;

end.
